<?php
/*
Plugin Name: پلاگین درگاه پرداخت آقای پرداخت ووکامرس نسخه 2
Plugin URI: http://aqayepardakht.ir/
Description: پلاگین پرداخت آنلاین درگاه آقای پرداخت برای فروشگاه ساز ووکامرس  . طراحی شده توسط <a target="_blank" href="http://aqayepardakht.ir/">آقای پرداخت</a>
Version: 2.0
Author: aqayepardakht.ir
Author URI: http://aqayepardakht.ir
Copyright: 2018 aqayepardakht.ir
*/

add_action('plugins_loaded', 'WC_AQAYEPARDAKHT', 0);

function WC_AQAYEPARDAKHT()
{
    if(!class_exists('WC_Payment_Gateway'))
        return;

    class WC_full_aqayepardakht extends WC_Payment_Gateway
    {
        public function __construct()
        {

            $this->id 			 	 = 'aqayepardakht';
            $this->method_title 	 = 'آقای پرداخت';
            $this->has_fields 	   	 = false;
            $this->init_form_fields();
            $this->init_settings();

            $this->title				= $this->settings['title'];
            $this->description			= $this->settings['description'];
            $this->NetBanan_Currency	= $this->settings['NetBanan_Currency'];
            $this->aqayepardakht_pin		= $this->settings['aqayepardakht_pin'];
            $this->redirect_page_id	    = $this->settings['redirect_page_id'];

            $this->msg['message'] = "";
            $this->msg['class'] = "";

            add_action('woocommerce_api_' . strtolower(get_class($this)), array($this, 'check_aqayepardakht_response'));
            add_action('valid-aqayepardakht-request', array($this, 'successful_request'));

            if(version_compare(WOOCOMMERCE_VERSION, '2.0.0', '>='))
                add_action('woocommerce_update_options_payment_gateways_aqayepardakht', array(&$this, 'process_admin_options'));
            else
                add_action('woocommerce_update_options_payment_gateways', array(&$this, 'process_admin_options'));

            add_action('woocommerce_receipt_aqayepardakht', array(&$this, 'receipt_page'));
        }

        private function aqayepardakhtapi($amount=0, $tc='', $desc='test woocommerce', $verify=false)
        {
            $res = false;
            try
            {
                $m = !empty($verify) ? 'verify' : 'create';

                $f = array(
                    'amount' => round( $this->NetBanan_Currency=='Rial' ? $amount/10 : $amount),
                    'pin' => $this->aqayepardakht_pin,
                    !empty($verify) ? 'transid' : 'callback' => $tc
                );

                if(empty($verify))
                    $f = array_merge($f, array('bank'=>'mellat','description'=>$desc));

                $f_ = '';
                foreach($f as $k=>$v)
                    $f_ .= $k . '=' . urlencode($v) . '&';

                rtrim($f_, '&');

                $ch = curl_init();
                curl_setopt($ch,CURLOPT_URL, "http://panel.aqayepardakht.ir/api/{$m}/");
                curl_setopt($ch,CURLOPT_POST, count($f));
                curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
                curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
                $res = curl_exec($ch);
                curl_close($ch);
            }
            catch(Exception $e)
            {
                return -900;
            }

            return !empty($res) ? $res : false;
        }

        function init_form_fields()
        {
            $this->form_fields = array(
                'enabled' => array(
                    'title' => 'فعال سازی/غیر فعال سازی :',
                    'type' => 'checkbox',
                    'label' => 'فعال سازی درگاه پرداخت آقای پرداخت',
                    'description' => 'برای امکان پرداخت کاربران از طریق این درگاه باید تیک فعال سازی زده شده باشد .',
                    'default' => 'no'
                ),
                'aqayepardakht_pin' => array(
                    'title' => 'شناسه درگاه :',
                    'type' => 'text',
                    'description' => 'شناسه درگاه خود را وارد نمایید .'
                ),
                'NetBanan_Currency' => array(
                    'title' => 'واحد پولی',
                    'type' => 'select',
                    'options' => array('Rial'=>'ریال','Toman'=>'تومان'),
                    'description' => "واحد پولی فروشگاه خود را انتخاب نمایید ."
                ),
                'title' => array(
                    'title' => 'عنوان درگاه :',
                    'type'=> 'text',
                    'description' => 'این عتوان در سایت برای کاربر نمایش داده می شود .',
                    'default' => 'درگاه پرداخت آقای پرداخت '
                ),
                'description' => array(
                    'title' => 'توضیحات درگاه :',
                    'type' => 'textarea',
                    'description' => 'این توضیحات در سایت، بعد از انتخاب درگاه توسط کاربر نمایش داده می شود .',
                    'default' => 'پرداخت وجه از طریق درگاه آقای پرداخت توسط تمام کارت های عضو شتاب .'
                ),
                'redirect_page_id' => array(
                    'title' => 'آدرس بازگشت',
                    'type' => 'select',
                    'options' => $this->get_pages('صفحه مورد نظر را انتخاب نمایید'),
                    'description' => "صفحه‌ای که در صورت پرداخت موفق نشان داده می‌شود را نشان دهید."
                )
            );
        }

        public function admin_options()
        {
            echo '<h3>'.__('درگاه پرداخت آقای پرداخت ', 'aqayepardakht').'</h3>';
            echo '<p>'.__('درگاه پرداخت اینترنتی آقای پرداخت ').'</p>';
            echo '<table class="form-table">';
            $this->generate_settings_html();
            echo '</table>';
        }

        function receipt_page($order_id)
        {
            global $woocommerce;
            $order = new WC_Order($order_id);
            $callback = ($this->redirect_page_id=="" || $this->redirect_page_id==0) ? get_site_url() . "/" : get_permalink($this->redirect_page_id);
            $callback = add_query_arg('wc-api', get_class($this), $callback);
            unset($woocommerce->session->zegersot);
            unset($woocommerce->session->zegersot_id);
            $woocommerce->session->zegersot = $order_id;

            $items_list = NULL;
            foreach ($order->get_items() as $item)
            {
                if(isset($items_list))
                    $items_list .= "-" . $item['name'];
                else
                    $items_list = $item['name'];
            }

            $callback = $callback . '&order_id=' . $order_id;
            $res = $this->aqayepardakhtapi($order->order_total, $callback, 'شناسه سفارش : ' . $order_id);
            if(empty($res) or $res == -900)
                echo 'اتصال به بانک برقرار نشد .';
            else if(strlen($res) > 5)
            {
                $woocommerce->session->zegersot_id = $res;
                header("Location: http://panel.aqayepardakht.ir/startpay/{$res}");
                exit;
            }
            else
                echo "خطا ({$res})";
        }

        function process_payment($order_id)
        {
            $order = &new WC_Order($order_id);
            return array('result' => 'success', 'redirect' => $order->get_checkout_payment_url(true));
        }


        function check_aqayepardakht_response()
        {
            global $woocommerce;
            $order_id = $_GET['order_id'];
            $order = &new WC_Order($order_id);

            $transid = @$_POST["transid"];
            if(!empty($transid))
            {
                $res = $this->aqayepardakhtapi($order->order_total, $transid, '', true);
                if(empty($res))
                {
                    $this->msg['class'] = 'woocommerce_error';
                    $this->msg['message'] = "پرداخت ناموفق";
                    $order->add_order_note('تراکنش پرداخت نشده است .');
                    $order->add_order_note($this->msg['message']);
                }
                else if($res == 1)
                {
                    $this->msg['message'] = "پرداخت شما با موفقیت انجام شد";
                    $this->msg['class'] = 'woocommerce_message';
                    $order->payment_complete();
                    $order->add_order_note($this->msg['message']);
                    $order->add_order_note('پرداخت انجام شد .<br/>کد پیگیری : ' . $transid);
                    $woocommerce->cart->empty_cart();
                }
                else
                {
                    $res = ($res == -900) ? 'ارتباط با بانک برقرار نشده است' : $res;
                    $this->msg['class'] = 'woocommerce_error';
                    $this->msg['message'] = 'خطا : ' . $res;
                    $order->add_order_note('پرداخت ناموفق');
                    $order->add_order_note($this->msg['message']);
                }
            }
            else
            {
                $this->msg['class'] = 'woocommerce_error';
                $this->msg['message'] = "پرداخت ناموفق";
                $order->add_order_note('اطلاعات ارسالی صحیح نمیباشد .');
                $order->add_order_note($this->msg['message']);
            }

            $redirect_url = ($this->redirect_page_id=="" || $this->redirect_page_id==0)?get_site_url() . "/":get_permalink($this->redirect_page_id);
            $redirect_url = add_query_arg(array('msg'=> base64_encode($this->msg['message']), 'type'=>$this->msg['class']), $redirect_url);
            wp_redirect($redirect_url);
            exit;
        }

        function get_pages($title = false, $indent = true)
        {
            $wp_pages = get_pages('sort_column=menu_order');
            $page_list = array();
            if ($title) $page_list[] = $title;
            foreach ($wp_pages as $page)
            {
                $prefix = '';
                if ($indent)
                {
                    $has_parent = $page->post_parent;
                    while($has_parent)
                    {
                        $prefix .=  ' - ';
                        $next_page = get_page($has_parent);
                        $has_parent = $next_page->post_parent;
                    }
                }
                $page_list[$page->ID] = $prefix . $page->post_title;
            }
            return $page_list;
        }
    }

    function woocommerce_add_aqayepardakht_gateway($methods)
    {
        $methods[] = 'WC_full_aqayepardakht';
        return $methods;
    }
    add_filter('woocommerce_payment_gateways', 'woocommerce_add_aqayepardakht_gateway');
}

if($_GET['msg']!='')
{
    add_action('the_content', 'showMessage');

    function showMessage($content)
    {
        return '<div class="' . htmlentities($_GET['type']) . '">' . base64_decode($_GET['msg']) . '</div>' . $content;
    }
}
?>